import os

print("Enter the size of RSA key: ")
rsa_size = int(input())

n = rsa_size
e = rsa_size
d = rsa_size
c = rsa_size
n_list = [] #change
n_list_new = []

for x in range(rsa_size-1,-1,-1):
	text = "N" + str(x) #change
	n_list.append(text)
	n_list_new.append(text)

for i in range(0,rsa_size): #N (0 to n-1)
	n_list_new[rsa_size-1-i] = "N" + str(i) + "_prime"
	for j in range(0,rsa_size*2): #Z (0 to 2n-1)
		filename = "N" + str(i) + "_Z" + str(j) + "_illegal.smt2" #change
		f = open(filename, "w")
		f.writelines(["(declare-fun modulus ( (_ BitVec " + str(rsa_size*2) + ") (_ BitVec " + str(rsa_size*2) + ") (_ BitVec " + str(rsa_size*2) + ")) (_ BitVec " + str(rsa_size*2) + "))\n"])
		f.writelines(["(declare-fun revpad ( (_ BitVec " + str(rsa_size*2) + ")) (_ BitVec " + str(rsa_size*2) + "))\n"])
		f.writelines(["(declare-fun neselect () (_ BitVec 2))\n"])
		f.writelines(["(declare-fun " + str(n_list_new[rsa_size-1-i]) + " () (_ BitVec 2))\n"])
		
		for x in range(0,rsa_size):
			f.writelines(["(declare-fun N" + str(x) + " () (_ BitVec 2))\n"])
			f.writelines(["(declare-fun E" + str(x) + " () (_ BitVec 2))\n"])
			f.writelines(["(declare-fun D" + str(x) + " () (_ BitVec 2))\n"])
			f.writelines(["(declare-fun C" + str(x) + " () (_ BitVec 2))\n"])
			
		f.writelines(["(define-fun rail0 ((a (_ BitVec 2))) (_ BitVec 1)\n ((_ extract 0 0) a))\n"])
		f.writelines(["(define-fun rail1 ((a (_ BitVec 2))) (_ BitVec 1)\n ((_ extract 1 1) a))\n"])
		f.writelines(["(define-fun datap ((a (_ BitVec 2))) (Bool)\n (or (= (_ bv1 2) a) (= (_ bv2 2) a)))\n"])
		f.writelines(["(define-fun nullp ((a (_ BitVec 2))) (Bool)\n (and (= (_ bv0 1) (rail0 a)) (= (_ bv0 1) (rail1 a))))\n"])
		f.writelines(["(define-fun th14 ((a (_ BitVec 1)) (b (_ BitVec 1)) (c (_ BitVec 1)) (d (_ BitVec 1))) (_ BitVec 1)\n (bvor a b c d))\n"])
		f.writelines(["(define-fun th33 ((a (_ BitVec 1)) (b (_ BitVec 1)) (c (_ BitVec 1))) (_ BitVec 1)\n (bvand a b c))\n"])
		
		f.writelines(["(define-fun mux ((a (_ BitVec " + str(rsa_size) + ")) (b (_ BitVec " + str(rsa_size) + ")) (sel (_ BitVec 1))) (_ BitVec " + str(rsa_size) + ")\n"])
		f.writelines(["(ite (= sel (_ bv0 1)) a b))\n"])
		
		function_name = "(define-fun nclmux ((a (_ BitVec " + str(rsa_size*2) + ")) (b (_ BitVec " + str(rsa_size*2) + ")) (s (_ BitVec 2))) (_ BitVec " + str(rsa_size*2) + ")"
		f.writelines(function_name)
		f.writelines(["\n(let\n("])
		count = 0
		for x in range(0,rsa_size):
			x_text = "(X" + str(x) + " ((_ extract " + str(count+1) + " " + str(count) + ") a))"
			y_text = "(Y" + str(x) + " ((_ extract " + str(count+1) + " " + str(count) + ") b))"
			count = count+2
			f.writelines(["\n"])
			f.writelines(x_text)
			f.writelines(["\n"])
			f.writelines(y_text)
		f.writelines(["\n)\n(let\n("])
		number = 0
		for x in range(0,rsa_size):
			line0 = "(I" + str(number) + " (th33 (rail0 X" + str(x) + ") (rail0 Y" + str(x) + ") (rail0 s)))"
			number = number+1
			line1 = "(I" + str(number) + " (th33 (rail0 X" + str(x) + ") (rail0 Y" + str(x) + ") (rail1 s)))"
			number = number+1
			line2 = "(I" + str(number) + " (th33 (rail0 X" + str(x) + ") (rail1 Y" + str(x) + ") (rail0 s)))"
			number = number+1
			line3 = "(I" + str(number) + " (th33 (rail1 X" + str(x) + ") (rail0 Y" + str(x) + ") (rail1 s)))"
			number = number+1
			line4 = "(I" + str(number) + " (th33 (rail0 X" + str(x) + ") (rail1 Y" + str(x) + ") (rail1 s)))"
			number = number+1
			line5 = "(I" + str(number) + " (th33 (rail1 X" + str(x) + ") (rail1 Y" + str(x) + ") (rail0 s)))"
			number = number+1
			line6 = "(I" + str(number) + " (th33 (rail1 X" + str(x) + ") (rail1 Y" + str(x) + ") (rail1 s)))"
			number = number+1
			line7 = "(I" + str(number) + " (th33 (rail1 X" + str(x) + ") (rail0 Y" + str(x) + ") (rail0 s)))"
			number = number+3
			line_list = [line0, line1, line2, line3, line4, line5, line6, line7]
			for y in line_list:
				f.writelines(["\n"])
				f.writelines(y)
			f.writelines(["\n"])
		f.writelines([")\n(let\n("])
		number = 0
		for x in range(0,rsa_size):
			line0 = "(F" + str(x) + "_0 (th14 I" + str(number) + " I" + str(number+1) + " I" + str(number+2) + " I" + str(number+3) + "))"
			line1 = "(F" + str(x) + "_1 (th14 I" + str(number+4) + " I" + str(number+5) + " I" + str(number+6) + " I" + str(number+7) + "))"
			f.writelines(["\n"])
			f.writelines(line0)
			f.writelines(["\n"])
			f.writelines(line1)
			number = number+10
		f.writelines(["\n)\n(let\n("])
		f.writelines(["\n(out (concat"])
		for x in range(rsa_size-1,-1,-1):
			f.writelines([" F" + str(x) + "_1 F" + str(x) + "_0"])
		f.writelines(["))\n)\n)))))\n"])
		
		f.writelines(["(define-fun RSA ((nreg (_ BitVec " + str(rsa_size*2) + ")) (ereg (_ BitVec " + str(rsa_size*2) + ")) (dreg (_ BitVec " + str(rsa_size*2) + ")) (neselect (_ BitVec 2)) (c (_ BitVec " + str(rsa_size*2) + "))) (_ BitVec " + str(rsa_size*4) + ")\n(let(\n"])
		count = 0
		for x in range(0,rsa_size):
			f.writelines(["(B" + str(x) + "((_ extract " + str(count+1) + " " + str(count) + ") ereg))\n"])
			f.writelines(["(K" + str(x) + "((_ extract " + str(count+1) + " " + str(count) + ") dreg))\n"])
			count = count + 2
		f.writelines(["(S ((_ extract 1 0) c)))\n"])
		f.writelines(["(let(\n"])
		f.writelines(["(B_zero (concat"])
		for x in range(rsa_size-1,-1,-1):
			f.writelines([" (rail0 B" + str(x) + ")"])
		f.writelines(["))\n"])
		f.writelines(["(B_one (concat"])
		for x in range(rsa_size-1,-1,-1):
			f.writelines([" (rail1 B" + str(x) + ")"])
		f.writelines(["))\n"])
		f.writelines(["(K_zero (concat"])
		for x in range(rsa_size-1,-1,-1):
			f.writelines([" (rail0 K" + str(x) + ")"])
		f.writelines(["))\n"])
		f.writelines(["(K_one (concat"])
		for x in range(rsa_size-1,-1,-1):
			f.writelines([" (rail1 K" + str(x) + ")"])
		f.writelines([")))\n"])
		f.writelines(["(let(\n"])
		f.writelines(["(F0 (mux B_zero K_zero (rail0 S)))\n"])
		f.writelines(["(F1 (mux B_one K_one (rail0 S)))\n"])
		f.writelines(["(F2 (mux B_zero K_zero (rail1 S)))\n"])
		f.writelines(["(F3 (mux B_one K_one (rail1 S))))\n"])
		f.writelines(["(let(\n"])
		f.writelines(["(Bp0 (mux F0 F2 (rail0 S)))\n"])
		f.writelines(["(Bp1 (mux F1 F3 (rail0 S))))\n"])
		f.writelines(["(let(\n"])
		for x in range(0,rsa_size):
			f.writelines(["(X" + str(x) + " ((_ extract " + str(x) + " " + str(x) + ") Bp0))\n"])
			f.writelines(["(Y" + str(x) + " ((_ extract " + str(x) + " " + str(x) + ") Bp1))\n"])
		f.writelines([")\n(let(\n"])
		f.writelines("(n_or_e (concat")
		for x in range(rsa_size-1,-1,-1):
			f.writelines([" Y" + str(x) + " X" + str(x)])
		f.writelines([")))\n(let(\n"])
		f.writelines(["(output_n_or_e (nclmux nreg n_or_e neselect)))\n"])
		f.writelines(["(let(\n"])
		f.writelines(["(m (modulus c dreg nreg)))\n"])
		f.writelines(["(let(\n"])
		f.writelines(["(output_m (revpad m)))\n"])
		f.writelines(["(let(\n"])
		f.writelines(["(final_output (concat output_m output_n_or_e)))\n"])
		f.writelines([")))))))))))\n"])
		
		f.writelines(["(assert (not (let(\n"])
		f.writelines(["(N (concat"])
		for x in range(rsa_size-1,-1,-1):
			f.writelines([" N" + str(x)])
		f.writelines(["))\n"])
		f.writelines(["(E (concat"])
		for x in range(rsa_size-1,-1,-1):
			f.writelines([" E" + str(x)])
		f.writelines(["))\n"])
		f.writelines(["(D (concat"])
		for x in range(rsa_size-1,-1,-1):
			f.writelines([" D" + str(x)])
		f.writelines(["))\n"])
		f.writelines(["(C (concat"])
		for x in range(rsa_size-1,-1,-1):
			f.writelines([" C" + str(x)])
		f.writelines(["))\n"])
		f.writelines(["(N_prime (concat"])
		for x in range(0,rsa_size): #change lines 164 to 177
			f.writelines([" " + n_list_new[x]])
		f.writelines(["))\n"])
		f.writelines(["(E_prime (concat"])
		for x in range(rsa_size-1,-1,-1):
			f.writelines([" E" + str(x)])
		f.writelines(["))\n"])
		f.writelines(["(D_prime (concat"])
		for x in range(rsa_size-1,-1,-1):
			f.writelines([" D" + str(x)])
		f.writelines(["))\n"])
		f.writelines(["(C_prime (concat"])
		for x in range(rsa_size-1,-1,-1):
			f.writelines([" C" + str(x)])
		f.writelines([")))\n"])
		f.writelines(["(let(\n"])
		f.writelines(["(Z (RSA N E D neselect C))\n"])
		f.writelines(["(Z_prime (RSA N_prime E_prime D_prime neselect C_prime)))\n"])
		f.writelines(["(let(\n"])
		count = 0
		for x in range(0,rsa_size*2):
			f.writelines(["(Z" + str(x) + " ((_ extract " + str(count+1) + " " + str(count) + ") Z))\n"])
			f.writelines(["(Z" + str(x) + "_prime ((_ extract " + str(count+1) + " " + str(count) + ") Z_prime))\n"])
			count = count+2
		f.writelines([")\n"])
		
		f.writelines(["(=>\n(and\n"])
		f.writelines(["(= N" + str(i) + "(_ bv1 2)) (= N" + str(i) + "_prime (_ bv2 2))\n"]) #change
		f.writelines(["(and\n(or (datap neselect) (nullp neselect))\n"])
		for x in range(0,rsa_size):
			if x != i:
				f.writelines(["(or (datap N" + str(x) + ") (nullp N" + str(x) + "))\n"]) #changes lines 195 to 199
		f.writelines(["))\n"])
		f.writelines(["(= Z" + str(j) + " Z" + str(j) + "_prime)\n"])
		f.writelines(["))))))"])
		f.writelines(["\n(check-sat)\n"])
		f.writelines(["(get-model)"])
	n_list_new[rsa_size-i-1] = "N" + str(i)
		
