import glob, os, threading
from queue import Queue, Empty
import time

def worker_func():
	while not stopped.is_set():
		try:
			com = q.get_nowait()
		except Empty:
			continue
		try:
			os.system(com)
		except Exception as e:
			print ("[-] Error running command %s", (str(e)))
		finally:
			q.task_done()

commands = []
t0 = time.time()
list_of_files = glob.glob('*.smt2')
for file_name in list_of_files:
	#F1 = open(file_name,'r')
	file_noext = os.path.splitext(file_name)[0]
	command = "z3 " + file_name
	commands.append(command)
	#os.system(command)
thread_count = 20
stopped = threading.Event()
q = Queue()
texttoprint = "-- Processing " + str(len(commands)) + " tasks in thread queue with " + str(thread_count) + " thread limit"
print (texttoprint)
for item in commands:
	q.put(item)
for i in range(thread_count):
	t = threading.Thread(target = worker_func)
	t.start()
q.join()
stopped.set()

t1 = time.time()
total = t1 - t0
tt = "Total time = " + str(total) + " seconds"
print(tt)
