import os
import shutil

print("Enter the size of RSA key: ")
rsa_size = int(input())
total_rails = rsa_size*2
total_number_of_files = rsa_size*4+1
n = rsa_size
e = rsa_size
d = rsa_size
ne_select = 1
gate_list = ['Iminus1']

filename = "and_trojan_base_illegal.smt2"
f = open(filename, "w")
f.writelines(["(set-logic QF_BV)\n\n"])
f.writelines(["(declare-fun NESELECT () (_ BitVec 2))\n"])
f.writelines(["(declare-fun boolsel () (_ BitVec 2))\n"])
f.writelines(["(declare-fun gl () (_ BitVec 1))\n\n"])

for x in range(0,rsa_size):
	f.writelines(["(declare-fun N" + str(x) + " () (_ BitVec 2))\n"])
	f.writelines(["(declare-fun E" + str(x) + " () (_ BitVec 2))\n"])
	f.writelines(["(declare-fun D" + str(x) + " () (_ BitVec 2))\n"])

f.writelines(["\n(define-fun rail0 ((a (_ BitVec 2))) (_ BitVec 1)\n ((_ extract 0 0) a))\n"])
f.writelines(["\n(define-fun rail1 ((a (_ BitVec 2))) (_ BitVec 1)\n ((_ extract 1 1) a))\n"])
f.writelines(["\n(define-fun datap ((a (_ BitVec 2))) (Bool)\n (or (= (_ bv1 2) a) (= (_ bv2 2) a)))\n"])
f.writelines(["\n(define-fun nullp ((a (_ BitVec 2))) (Bool)\n (and (= (_ bv0 1) (rail0 a)) (= (_ bv0 1) (rail1 a))))\n"])
f.writelines(["\n(define-fun th22 ((a (_ BitVec 1)) (b (_ BitVec 1)) (gl (_ BitVec 1))) (_ BitVec 1)\n (ite\n (= (_ bv1 1) (bvand (bvnot a) (bvnot b))) (_ bv0 1)\n (ite\n (= (_ bv1 1) (bvand a b)) (_ bv1 1) gl)))\n"])
f.writelines(["\n(define-fun th14 ((a (_ BitVec 1)) (b (_ BitVec 1)) (c (_ BitVec 1)) (d (_ BitVec 1)) (gl (_ BitVec 1))) (_ BitVec 1)\n (ite\n (= (_ bv1 1) (bvand (bvnot a) (bvnot b) (bvnot c) (bvnot d))) (_ bv0 1)\n (ite\n (= (_ bv1 1) (bvor a b c d)) (_ bv1 1) gl)))\n"])
f.writelines(["\n(define-fun th33 ((a (_ BitVec 1)) (b (_ BitVec 1)) (c (_ BitVec 1)) (gl (_ BitVec 1))) (_ BitVec 1)\n (ite\n (= (_ bv1 1) (bvand (bvnot a) (bvnot b) (bvnot c))) (_ bv0 1)\n (ite\n (= (_ bv1 1) (bvand a b c)) (_ bv1 1) gl)))\n"])
f.writelines(["\n(assert\n (not\n  (let((Iminus1 (th22 (rail1 boolsel) (rail0 boolsel) gl)))\n(let("])

#boolean MUX uses E, D and bool_sel
for x in range(0,rsa_size):
	line1 = "\n(I" + str(x) + "_0 (bvor (bvand (bvnot Iminus1) (rail0 E" + str(x) + ")) (bvand Iminus1 (rail0 D" + str(x) +"))))" 
	f.writelines(line1)
	gate = "I" + str(x) + "_0"
	gate_list.append(gate)
	line2 = "\n(I" + str(x) + "_1 (bvor (bvand (bvnot Iminus1) (rail1 E" + str(x) + ")) (bvand Iminus1 (rail1 D" + str(x) +"))))"
	f.writelines(line2)
	gate = "I" + str(x) + "_1"
	gate_list.append(gate)

f.writelines(["\n)\n(let("])
number = 0

#ncl mux uses the outputs of the boolean mux and n
for x in range(0,rsa_size):
	line0 = "(J" + str(number) + " (th33 (rail0 N" + str(x) + ") I" + str(x) + "_0 (rail0 NESELECT) gl))"
	gate = "J" + str(number)
	gate_list.append(gate)
	number = number+1
	line1 = "(J" + str(number) + " (th33 (rail0 N" + str(x) + ") I" + str(x) + "_0 (rail1 NESELECT) gl))"
	gate = "J" + str(number)
	gate_list.append(gate)
	number = number+1
	line2 = "(J" + str(number) + " (th33 (rail0 N" + str(x) + ") I" + str(x) + "_1 (rail0 NESELECT) gl))"
	gate = "J" + str(number)
	gate_list.append(gate)
	number = number+1
	line3 = "(J" + str(number) + " (th33 (rail1 N" + str(x) + ") I" + str(x) + "_0 (rail1 NESELECT) gl))"
	gate = "J" + str(number)
	gate_list.append(gate)
	number = number+1
	line4 = "(J" + str(number) + " (th33 (rail0 N" + str(x) + ") I" + str(x) + "_1 (rail1 NESELECT) gl))"
	gate = "J" + str(number)
	gate_list.append(gate)
	number = number+1
	line5 = "(J" + str(number) + " (th33 (rail1 N" + str(x) + ") I" + str(x) + "_1 (rail0 NESELECT) gl))"
	gate = "J" + str(number)
	gate_list.append(gate)
	number = number+1
	line6 = "(J" + str(number) + " (th33 (rail1 N" + str(x) + ") I" + str(x) + "_1 (rail1 NESELECT) gl))"
	gate = "J" + str(number)
	gate_list.append(gate)
	number = number+1
	line7 = "(J" + str(number) + " (th33 (rail1 N" + str(x) + ") I" + str(x) + "_0 (rail0 NESELECT) gl))"
	gate = "J" + str(number)
	gate_list.append(gate)
	number = number+3
	line_list = [line0, line1, line2, line3, line4, line5, line6, line7]
	for y in line_list:
		f.writelines(["\n"])
		f.writelines(y)
	f.writelines(["\n"])

f.writelines([")\n(let\n("])
number = 0

for x in range(0,rsa_size):
	line0 = "(F" + str(x) + "_0 (th14 J" + str(number) + " J" + str(number+1) + " J" + str(number+2) + " J" + str(number+3) + " gl))"
	gate = "F" + str(x) + "_0"
	gate_list.append(gate)
	line1 = "(F" + str(x) + "_1 (th14 J" + str(number+4) + " J" + str(number+5) + " J" + str(number+6) + " J" + str(number+7) + " gl))"
	gate = "F" + str(x) + "_1"
	gate_list.append(gate)
	f.writelines(["\n"])
	f.writelines(line0)
	f.writelines(["\n"])
	f.writelines(line1)
	number = number + 10

f.writelines(["\n)"])
f.writelines(["(=>\n (and\n(= (_ bv0 1) gl))\n"])
#f.writelines(["(= (_ bv0 1) Iminus1))))))))\n\n"])
#f.writelines(["(check-sat)\n(get-model)"])
f.close()

for x in gate_list:
	newfile = "illegal_gate_" + str(x) + ".smt2"
	shutil.copyfile(filename,newfile)
	f = open(newfile,"a+")
	f.writelines(["(= (_ bv0 1) " + str(x) + "))))))))\n\n"])
	f.writelines(["(check-sat)\n(get-model)"])
	f.close()
os.remove(filename)
